/*
 * Ruler.h
 *
 *  Created on: May 8, 2018
 *      Author: yunya
 */

#ifndef RECTANGLE_RULER_H_
#define RECTANGLE_RULER_H_
#include "../UI.h"
#include "../UIListener.hpp"

class Ruler: public UIListener {
	cv::Point distanceTextPos {5, 60};
	cv::Point confTextPos {5, 75};
	cv::Scalar textFontColor {20, 20, 20};

	UI *ui;
	int *lastKey;
	float distance = 0;
	float widthInCM = 0;
	float focalLength;
	int HFOV = 65;
	bool inputtingVal = false;
	std::deque<char> numBuild;

public:
	Ruler(UI *ui, int *lastKey);
	float estimateFocalLength(int HFOV);
	int estimateDistance(cv::Rect rect);
	void update(cv::Rect rect);
	void componentSetup();
	void updateUI();
	void toggleInput();
	virtual ~Ruler();

private:
	void inputUpdate();
};

#endif /* RECTANGLE_RULER_H_ */
